import pytest
import requests

BASE_URL = 'http://kdtx-test.itheima.net/api'

class TestkdtxLogin(object):
    @pytest.mark.parametrize("username,password,ast",[
        ("manager","HM_2023_test",("操作成功",200,{"name": "测试开发提升课01", "subject": "6", "price": 899, "applicablePerson": "2","info": "测试开发提升课01"})),
        ("manager", "123456", ("用户不存在/密码错误", 500)),
        ("uusseerr", "HM_2023_test", ("用户不存在/密码错误", 500)),
    ])
    def test_login(self,username,password,ast):
        uuid = requests.get(f'{BASE_URL}/captchaImage').json()['uuid']
        login_data = {"username": username, "password": password, "code": "2", "uuid": uuid}
        login_res = requests.post(f'{BASE_URL}/login', json=login_data)
        assert login_res.json()['msg'] == ast[0]
        assert login_res.json()['code'] == ast[1]
        if len(ast)==3:
            token, cookies = login_res.json()['token'], login_res.cookies.get_dict()
            course_data = ast[2]
            add_course_res = requests.post(f'{BASE_URL}/clues/course', json=course_data, headers={'Authorization': token},cookies=cookies)
            assert add_course_res.json()['msg'] == ast[0]
            assert add_course_res.json()['code'] == ast[1]